Imports System.Runtime.InteropServices
Public Class frmCamera
    Const WM_CAP As Short = &H400S
    Const WM_CAP_DRIVER_CONNECT As Integer = WM_CAP + 10
    Const WM_CAP_DRIVER_DISCONNECT As Integer = WM_CAP + 11
    Const WM_CAP_EDIT_COPY As Integer = WM_CAP + 30
    Const WM_CAP_SET_PREVIEW As Integer = WM_CAP + 50
    Const WM_CAP_SET_PREVIEWRATE As Integer = WM_CAP + 52
    Const WM_CAP_SET_SCALE As Integer = WM_CAP + 53
    Const WS_CHILD As Integer = &H40000000
    Const WS_VISIBLE As Integer = &H10000000
    Const SWP_NOMOVE As Short = &H2S
    Const SWP_NOSIZE As Short = 1
    Const SWP_NOZORDER As Short = &H4S
    Const HWND_BOTTOM As Short = 1
    Dim iDevice As Integer = 0 '  
    Dim hHwnd As Integer '  
    Declare Function SendMessage Lib "user32" Alias "SendMessageA" _
        (ByVal hwnd As Integer, ByVal wMsg As Integer, ByVal wParam As Integer, _
        <MarshalAs(UnmanagedType.AsAny)> ByVal lParam As Object) As Integer
    Declare Function SetWindowPos Lib "user32" Alias "SetWindowPos" (ByVal hwnd As Integer, _
        ByVal hWndInsertAfter As Integer, ByVal x As Integer, ByVal y As Integer, _
        ByVal cx As Integer, ByVal cy As Integer, ByVal wFlags As Integer) As Integer
    Declare Function DestroyWindow Lib "user32" (ByVal hndw As Integer) As Boolean
    Declare Function capCreateCaptureWindowA Lib "avicap32.dll" _
        (ByVal lpszWindowName As String, ByVal dwStyle As Integer, _
        ByVal x As Integer, ByVal y As Integer, ByVal nWidth As Integer, _
        ByVal nHeight As Short, ByVal hWndParent As Integer, _
        ByVal nID As Integer) As Integer
    Declare Function capGetDriverDescriptionA Lib "avicap32.dll" (ByVal wDriver As Short, _
        ByVal lpszName As String, ByVal cbName As Integer, ByVal lpszVer As String, _
        ByVal cbVer As Integer) As Boolean
    Private Sub LoadDeviceList()
        Dim strName As String = Space(1000)
        Dim strVer As String = Space(1000)
        Dim bReturn As Boolean
        Dim x As Integer = 0
        '   
        Do
            '    + 
            bReturn = capGetDriverDescriptionA(x, strName, 100, strVer, 100)
            '    
            If bReturn Then ComboBox1.Items.Add(strName.Trim)
            x += 1
        Loop Until bReturn = False
    End Sub
    Private Sub OpenPreviewWindow()
        Dim iHeight As Integer = PictureBox1.Height
        Dim iWidth As Integer = PictureBox1.Width
        '    
        hHwnd = capCreateCaptureWindowA(iDevice, WS_VISIBLE Or WS_CHILD, 0, 0, 640, _
            480, PictureBox1.Handle.ToInt32, 0)
        '  
        If SendMessage(hHwnd, WM_CAP_DRIVER_CONNECT, iDevice, 0) Then
            '  
            SendMessage(hHwnd, WM_CAP_SET_SCALE, True, 0)
            ' 
            SendMessage(hHwnd, WM_CAP_SET_PREVIEWRATE, 66, 0)
            '    
            SendMessage(hHwnd, WM_CAP_SET_PREVIEW, True, 0)
            '   
            SetWindowPos(hHwnd, HWND_BOTTOM, 0, 0, PictureBox1.Width, PictureBox1.Height, _
                    SWP_NOMOVE Or SWP_NOZORDER)
            SAVEBUTTON.Enabled = True
            STOPBUTTON.Enabled = True
            STARTBUTTON.Enabled = False
        Else
            '    
            DestroyWindow(hHwnd)
            SAVEBUTTON.Enabled = False
        End If
    End Sub
    Private Sub frmVideoCapture_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LoadDeviceList()
        If ComboBox1.Items.Count > 0 Then
            STARTBUTTON.Enabled = True
            ComboBox1.SelectedIndex = 0
            STARTBUTTON.Enabled = True
        Else
            ComboBox1.Items.Add("NO CAMERA")
            STARTBUTTON.Enabled = False
        End If
        STOPBUTTON.Enabled = False
        SAVEBUTTON.Enabled = False
        PictureBox1.SizeMode = PictureBoxSizeMode.StretchImage
    End Sub
    Private Sub STARTBUTTON_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles STARTBUTTON.Click
        iDevice = ComboBox1.SelectedIndex
        OpenPreviewWindow()
    End Sub
    Private Sub ClosePreviewWindow()
        '   
        SendMessage(hHwnd, WM_CAP_DRIVER_DISCONNECT, iDevice, 0)
        '  
        DestroyWindow(hHwnd)
    End Sub
    Private Sub STOPBUTTON_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles STOPBUTTON.Click
        ClosePreviewWindow()
        SAVEBUTTON.Enabled = False
        STARTBUTTON.Enabled = True
        STOPBUTTON.Enabled = False
    End Sub
    Private Sub SAVEBUTTON_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SAVEBUTTON.Click
        Dim data As IDataObject
        Dim bmap As Image
        '   
        SendMessage(hHwnd, WM_CAP_EDIT_COPY, 0, 0)
        '       
        data = Clipboard.GetDataObject()
        If data.GetDataPresent(GetType(System.Drawing.Bitmap)) Then
            bmap = CType(data.GetData(GetType(System.Drawing.Bitmap)), Image)
            PictureBox1.Image = bmap
            ClosePreviewWindow()
            SAVEBUTTON.Enabled = False
            STOPBUTTON.Enabled = False
            STARTBUTTON.Enabled = True
            If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
                bmap.Save(SaveFileDialog1.FileName, Imaging.ImageFormat.Bmp)
            End If
        End If
    End Sub
    Private Sub frmVideoCapture_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If STOPBUTTON.Enabled Then
            ClosePreviewWindow()
        End If
    End Sub
End Class